--- old/usr/src/uts/common/os/fio.c	2015-08-09 12:48:00.700382821 +0300
+++ new/usr/src/uts/common/os/fio.c	2015-08-09 12:48:00.713384166 +0300
@@ -837,11 +837,14 @@
  * Duplicate all file descriptors across a fork.
  */
 void
-flist_fork(uf_info_t *pfip, uf_info_t *cfip)
+flist_fork(proc_t *pp, proc_t *cp)
 {
 	int fd, nfiles;
 	uf_entry_t *pufp, *cufp;
 
+	uf_info_t *pfip = P_FINFO(pp);
+	uf_info_t *cfip = P_FINFO(cp);
+
 	mutex_init(&cfip->fi_lock, NULL, MUTEX_DEFAULT, NULL);
 	cfip->fi_rlist = NULL;
 
@@ -859,6 +862,14 @@
 		cufp->uf_alloc = pufp->uf_alloc;
 		cufp->uf_flag = pufp->uf_flag;
 		cufp->uf_busy = pufp->uf_busy;
+
+		if (cufp->uf_file != NULL && cufp->uf_file->f_vnode != NULL) {
+			VOP_IOCTL(cufp->uf_file->f_vnode, F_FORKED,
+				(intptr_t)cp,
+				FKIOCTL,
+				kcred, NULL, NULL);
+		}
+
 		if (pufp->uf_file == NULL) {
 			ASSERT(pufp->uf_flag == 0);
 			if (pufp->uf_busy) {
@@ -944,6 +955,9 @@
 	offset = fp->f_offset;
 
 	vp = fp->f_vnode;
+	if (vp != NULL)
+		VOP_IOCTL(vp, F_CLOSED, (intptr_t)ttoproc(curthread),
+			FKIOCTL, kcred, NULL, NULL);
 
 	error = VOP_CLOSE(vp, flag, count, offset, fp->f_cred, NULL);
 
